﻿@using Portal.Models.EmergencyDCLOrderCreation;
@using System.Web.Mvc;
@using System.Web.UI.WebControls;
@using System.Data;
@using Portal.Controllers;
@using DevExpress.Web.ASPxPager;

@model Toyota.Common.Web.MVC.ModelHolder

<script src="@Url.Content("~/Scripts/MicrosoftAjax.js")" type="text/javascript"></script>
<script src="@Url.Content("~/Scripts/MicrosoftMvcValidation.js")" type="text/javascript"></script>

<script type="text/javascript">
    var rowCount = 1;

    function AddRow(s, e) {
        DCLEmergency.PerformCallback();
        rowCount++;
    }

    function BeginAddRow(s, e) {
        e.customArgs["rowCount"] = rowCount;
    }
    function OnDeliveryTypeSelected(s, e) {
        cbDeliveryNo.SetText('');
        PickupDate.SetText('');
        grlLPHeader.SetText('');
        Route.SetText('');
        Rate.SetText('');
        Reason.SetText('');
        check = s.GetSelectedItem().text;
        if (s.GetSelectedItem().text == "Additional Pickup") {
            cbDeliveryNo.SetEnabled(false);
            PickupDate.SetEnabled(true);
            grlLPHeader.SetEnabled(true);
            Route.SetEnabled(true);
            Rate.SetEnabled(true);
            Reason.SetEnabled(true);
            setDefaultGrid(check);
        }
        else if (s.GetSelectedItem().text == "Regular Pickup") {
            cbDeliveryNo.SetEnabled(true);
            PickupDate.SetEnabled(true);
            grlLPHeader.SetEnabled(true);
            Route.SetEnabled(true);
            Rate.SetEnabled(true);
            Reason.SetEnabled(true);
            setDefaultGrid(check);
        }
    }

    function setDefaultGrid(check) {
        DCLEmergencyContent.PerformCallback();
        DCLEmergency.UnselectAllRowsOnPage();
        for (var indexPartial = DCLEmergency.GetTopVisibleIndex(); indexPartial < DCLEmergency.GetVisibleRowsOnPage(); indexPartial++) {
            Suppliers = ASPxClientControl.GetControlCollection().GetByName("grlSupplier" + indexPartial);
            Docks = ASPxClientControl.GetControlCollection().GetByName("grlDock" + indexPartial);
            ArrTime = ASPxClientControl.GetControlCollection().GetByName("ArrTime" + indexPartial);
            DeptSuppTime = ASPxClientControl.GetControlCollection().GetByName("DeptSuppTime" + indexPartial);

            ArrPlan = ASPxClientControl.GetControlCollection().GetByName("ArrPlan" + indexPartial);
            DeptPlan = ASPxClientControl.GetControlCollection().GetByName("DeptPlan" + indexPartial);
            
            Suppliers.SetText("");
            GetPerfomDelivery();
            Docks.SetText("");
            if (check == "Regular Pickup") {
                ArrTime.SetEnabled(false);
                DeptSuppTime.SetEnabled(false);
                ArrPlan.SetEnabled(false);
                DeptPlan.SetEnabled(false);
                Suppliers.SetEnabled(false);
                Docks.SetEnabled(false);
//                ArrTime.SetText('');
//                DeptSuppTime.SetText('');
//                ArrPlan.SetText('');
//                DeptPlan.SetText('');
            }
            else {
                ArrTime.SetEnabled(true);
                DeptSuppTime.SetEnabled(true);
                ArrPlan.SetEnabled(true);
                DeptPlan.SetEnabled(true);
                Suppliers.SetEnabled(true);
                Docks.SetEnabled(true);
            }
        }
        
    }
    
    function CheckOtherIsCheckedByGVID(s, e) {
        var me = s.GetMainElement();
        var IsChecked = s.GetChecked();
        var CurrentRdbID = s.name;
        //Parent = document.getElementById('grdLPCode');
        var items = Parent.getElementsByTagName('input');

        for (i = 0; i < items.length; i++) {
            if (items[i].name != CurrentRdbID && items[i].name.substring(0, 3) == "rdo") {
                alert(items[i].name);
                alert(items[i].checked);
                if (items[i].checked) {
                    items[i].checked = false;
                    //                    items[i].parentElement.parentElement.style.backgroundColor = 'white';
                    //                    items[i].parentElement.parentElement.style.color = 'black';
                }
            }
        }
    }

    function CheckComboGrid(s, e) {
        var me = s.GetMainElement();
        alert(me)
    }

    function addRow(s, e) {
        DCLEmergency.AddNewRow();
    }

    function RowAdding(s,e){
        DCLEmergency.PerformCallback();
    }
    var DockAll;
    var SupplierAll;
    var ArrTimeAll;
    var DepTimeAll;
    var ArrPlanAll;
    var DepPlanAll;

    function getDeliveryNo(s, e) {

        if (rdoDeliveryType.GetSelectedIndex() == -1) {
            setTextBoxDefault();
            alert("Please choose the pickup type");

        }
        else {
            
            if (rdoDeliveryType.GetSelectedItem().text) {
                $.ajax({
                    type: "POST",
                    url: "@Url.Content("~/EmergencyDCLOrderCreation/getDeliveryDetail")",
                    data: {
                        DeliveryNo: cbDeliveryNo.GetText()
                    },
                    success: function (result) {

                        PickupDate.SetText(result.PickUpDate);
                        grlLPHeader.SetText(result.LPCode);
                        Route.SetText(result.Route);
                        Rate.SetText(result.Rate);
                        Reason.SetText(result.Reason);

                        //cbDeliveryNo.SetEnabled(false);
                        PickupDate.SetEnabled(false);
                        grlLPHeader.SetEnabled(false);
                        Route.SetEnabled(false);
                        Rate.SetEnabled(false);

                        DockAll = result.DockAll;
                        SupplierAll = result.SupplierAll;
                        ArrTimeAll = result.ArrTimeAll;
                        DepTimeAll = result.DeptSuppTimeAll;
                        ArrPlanAll = result.ArrPlanAll;
                        DepPlanAll = result.DeptPlanAll;
                        
                        SetGrid();
                    },
                    error: function (result) {
                        alert("Data not exist");
                    }
                });
            }
        }
        
    }
    function DeliveryBeginCallBack(s, e) {
        e.customArgs["PickupDate"] = getFormatyyyyMMdd(PickupDate.GetText());
        e.customArgs["Route"] = Route.GetText();
    }
    function GetPerfomDelivery(s, e) {

        if (rdoDeliveryType.GetSelectedIndex() == -1) {
            setTextBoxDefault();
            alert("Please checked the pickup type");
        }
        else
        {
            if (rdoDeliveryType.GetSelectedItem().text == "Regular Pickup") {
                cbDeliveryNo.PerformCallback();
            }
            
        }
        
    }

    function getLogisticPartner(s, e) {
        $.ajax({
            type: "POST",
            url: "/EmergencyDCLOrderCreation/getDeliveryDetail",
            data: {
                Input: grlLPHeader.GetText(),
                Parameter: '3'
            },
            success: function (result) {
                cbDeliveryNo.SetText(result.DeliveryNo);
                PickupDate.SetText(result.PickUpDate);
                //grlLPHeader.SetText(result.LPCode);
                Route.SetText(result.Route);
                Rate.SetText(result.Rate);
                Reason.SetText(result.Reason);

                cbDeliveryNo.SetEnabled(false);
                PickupDate.SetEnabled(false);
                //grlLPHeader.SetEnabled(false);
                Route.SetEnabled(false);
                Rate.SetEnabled(false);
                
            },
            error: function (result) {
                alert("Data not exist");
            }
        });
    }
    function LogisticPartnerBeginCallBack(s, e) {
        e.customArgs["DeliveryNo"] = currDeliveryNo;
    }

   
    function setTextBoxDefault(s,e){
        cbDeliveryNo.SetText('');
        PickupDate.SetText('');
        grlLPHeader.SetText('');
        Route.SetText('');
        Rate.SetText('');
        Reason.SetText('');
    }

    var RouteValue;
    function OnRouteSelected(s, e) {
        GetPerfomDelivery();
        RouteValue = s.GetText();
        Rate.PerformCallback();
    }
    function RateBeginCallBack(s, e) {
        e.customArgs["Route"] = RouteValue;
    }
    function SetGrid() {
        if (DockAll.length > 0) {
            DockAll = DockAll.substring(0, DockAll.length - 1);
            SupplierAll = SupplierAll.substring(0, SupplierAll.length - 1);
            ArrTimeAll = ArrTimeAll.substring(0, ArrTimeAll.length - 1);
            DepTimeAll = DepTimeAll.substring(0, DepTimeAll.length - 1);
            ArrPlanAll = ArrPlanAll.substring(0, ArrPlanAll.length - 1);
            DepPlanAll = DepPlanAll.substring(0, DepPlanAll.length - 1);
        }
        
        valuesD = DockAll.split(',');
        valuesS = SupplierAll.split(',');
        valuesAT = ArrTimeAll.split(',');
        valuesDT = DepTimeAll.split(',');
        valuesAP = ArrPlanAll.split(',');
        valuesDP = DepPlanAll.split(',');
    
        for (var indexPartial = 0; indexPartial < 20; indexPartial++) {
            Docks = ASPxClientControl.GetControlCollection().GetByName("grlDock" + indexPartial);
            Docks.SetText(valuesD[indexPartial]);
            Suppliers = ASPxClientControl.GetControlCollection().GetByName("grlSupplier" + indexPartial);
            Suppliers.SetText(valuesS[indexPartial]);

            ArrTime = ASPxClientControl.GetControlCollection().GetByName("ArrTime" + indexPartial);
            ArrTime.SetText(valuesAT[indexPartial]);
            DeptSuppTime = ASPxClientControl.GetControlCollection().GetByName("DeptSuppTime" + indexPartial);
            DeptSuppTime.SetText(valuesDT[indexPartial]);

            ArrPlan = ASPxClientControl.GetControlCollection().GetByName("ArrPlan" + indexPartial);
            ArrPlan.SetText(valuesAP[indexPartial]);
            DeptPlan = ASPxClientControl.GetControlCollection().GetByName("DeptPlan" + indexPartial);
            DeptPlan.SetText(valuesDP[indexPartial])
        }
    }
    function getFormatyyyyMMdd(value) {

        var year = value.substring(6, 10);
        var month = value.substring(3, 5);
        var date = value.substring(0, 2);

        var hasil = year + "-" + month + "-" + date;
        return hasil;

    }
</script>

<table border="0" width="100%" style="padding-bottom:4px;">
    <tr>
        <td width="62px">
            Type 
            <b style="color:Red;">*</b>
        </td>
        <td>
            @Html.DevExpress().RadioButtonList(
                setting =>
                {
                    setting.Name = "rdoDeliveryType";
                    setting.Properties.Items.Add("Additional Pickup", "001");
                    setting.Properties.Items.Add("Regular Pickup", "002");
                    setting.Properties.RepeatDirection = RepeatDirection.Horizontal;
                    setting.ControlStyle.Border.BorderStyle = BorderStyle.None;
                    setting.Properties.ClientSideEvents.SelectedIndexChanged = "OnDeliveryTypeSelected";
                }
            ).GetHtml()
        </td>   
    </tr>
</table>

<table border="0" width="100%">
    <tr>
        <td width="80px">
         <label for="LP">Delivery No</label>
        </td>
        <td width = "160px">    
            @Html.Partial("PartialComboDelivery")
        </td>
           
        <td width="100px">
            Logistic Partner
        </td>
        <td width = "160px">   
            @Html.Common().DevExpress().GridLookup(
                s =>
                {
                    s.Name = "grlLPHeader";
                    s.GridProperties.Name = "grlLPHeaderGrid";
                    s.GridProperties.KeyFieldName = "LPCode";
                    s.Width = 150;
                    s.GridProperties.Width = 150;
                    s.GridProperties.CallbackRouteValues = new { Controller = "EmergencyDCLOrderCreation", Action = "LPPartialEmergency" };                      
                    s.GridProperties.Height = 80;
                    s.GridProperties.SettingsBehavior.AllowSelectSingleRowOnly = true;
                       
                    s.GridProperties.Columns.Add(c =>
                    {
                        c.Name = "LPCode";
                        c.FieldName = "LPCode";
                        c.Caption = "LP Code";

                        c.Width = Unit.Pixel(80);
                            c.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    });
                    s.GridProperties.Columns.Add(c =>
                    {
                        c.Name = "LPName";
                        c.FieldName = "LPName";
                        c.Caption = "LP Name";
                        c.Width = 140;
                    });
                }
            ).Bind(ViewData["LogisticPartnerData"]).GetHtml()
        </td>

        <td width="60px">
            Rate
        </td>
        <td>
            @Html.Partial("PartialComboRate")
        </td>
    </tr>

    <tr>
        <td width="80px">
            Pick Up Date
        </td>
        <td  width="160px">     
            @Html.DevExpress().DateEdit(
                settings =>
                {
                    settings.Name = "PickupDate";
                    settings.Width = Unit.Pixel(150);
                    settings.Properties.DisplayFormatString = "dd.MM.yyyy";
                    settings.Properties.EditFormatString = "dd.MM.yyyy";
                    settings.Properties.MinDate = DateTime.Now.AddDays(0);
                    settings.Properties.ClientSideEvents.DateChanged = "GetPerfomDelivery";
                }
            ).GetHtml()
        </td>

        <td width="100px">
            Route
        </td>     
        <td>
            @Html.Partial("PartialComboRoute")
        </td>

        <td width="60px">
            Reason
        </td>
        <td>
            @Html.DevExpress().ComboBox(
                settings =>
                {
                    settings.Name = "Reason";
                    settings.Properties.ValueField = "Reason";
                    settings.Properties.TextField = "Reason";
                    settings.Width = Unit.Pixel(150);
                    settings.Properties.Items.Add("Emergency Order");
                }
            ).GetHtml()
        </td>
    </tr>
</table>       
        
<table width="100%" border="0" style="padding-top:4px;">
    <tr>
        <td align="left">
            @Html.DevExpress().Button(
                settings =>
                {
                    settings.Name = "clearItem";
                    settings.Text = "Clear Item";
                    settings.Width = 100;
                    settings.ClientSideEvents.Click = "ClearItem";                      
                }
            ).GetHtml()
        </td>
        <td align="right" width="200px">
            @Html.DevExpress().Button(
                settings =>
                {
                    settings.Name = "addSubmit";
                    settings.Text = "Submit";
                    settings.Width = 80;                     
                    settings.ClientSideEvents.Click = "CheckValidation";
                }
            ).GetHtml()
        </td>
        <td align="right" width="80px" style="padding-right:5px">
            @Html.DevExpress().Button(
                settings =>
                {
                    settings.Name = "addCancel";
                    settings.Text = "Cancel";
                    settings.Width = 80;
                    settings.ClientSideEvents.Click = "function (s, e) { popupCancel.Show(); }";                        
                    
                }
            ).GetHtml()
        </td>
    </tr>
</table>